



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS开发基础-Plist实现嵌套模型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS开发基础-Plist实现嵌套模型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 00:03:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>一、plist文件结构图</h4>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/689938/201602/689938-20160228163709643-876020444.png" /></p>
<p>　　说明：&nbsp;title&nbsp;属性表示该&nbsp;item&nbsp;下汽车名字的首字母，&nbsp;cars&nbsp;属性存放首字母为&nbsp;title&nbsp;的汽车，&nbsp;icon&nbsp;属性存放图片的名称，&nbsp;name&nbsp;属性存放汽车的名字。</p>
<h4>二、代码实例</h4>
<p>　　新建一个继承自&nbsp;NSObject&nbsp;的类，命名为&nbsp;WJQCars&nbsp;，该类用于存放首字母相同的汽车。</p>
<div>
<pre class="prettyprint linenums"> //  WJQCars.h<br />
 @interface WJQCars : NSObject<br />
 @property (nonatomic, copy) NSString *name;<br />
 @property (nonatomic, copy) NSString *icon;

 - (instancetype)initWithDict:(NSDictionary *)dict;<br />
 + (instancetype)carsWithDict:(NSDictionary *)dict;<br />
 @end</pre>
</div>
<div>
<pre class="prettyprint linenums"> //  WJQCars.m<br />
 @implementation WJQCars

 - (instancetype)initWithDict:(NSDictionary *)dict {<br />
     self = [super init];<br />
     if (self) {<br />
         self.name = dict[@"name"];<br />
         self.icon = dict[@"icon"];<br />
     }<br />
     return self;<br />
 }

 + (instancetype)carsWithDict:(NSDictionary *)dict {<br />
     return [[self alloc] initWithDict:dict];<br />
 }</pre>
</div>
<p>　　新建一个继承自&nbsp;NSObject&nbsp;的类，并命名为&nbsp;WJQCarsGroup&nbsp;，该类用于存放不同的&nbsp;WJQCars&nbsp;。</p>
<div>
<pre class="prettyprint linenums"> //  WJQCarsGroup.h<br />
 @interface WJQCarsGroup : NSObject<br />
 @property (nonatomic, copy) NSString *title;<br />
 @property (nonatomic, strong) NSArray *cars;

 - (instancetype)initWithDict:(NSDictionary *)dict;<br />
 + (instancetype)carsGroupWithDict:(NSDictionary *)dict;<br />
 @end</pre>
</div>
<p>　　在&nbsp;WJQCarsGroup.m&nbsp;中导入&nbsp;WJQCars.h&nbsp;，实现文件代码如下：</p>
<div>
<pre class="prettyprint linenums"> //  WJQCarsGroup.m<br />
 - (instancetype)initWithDict:(NSDictionary *)dict {<br />
     self = [super init];<br />
     if (self) {<br />
         self.title = dict[@"title"];<br />
         NSArray *dictCars = dict[@"cars"];<br />
         // 有助于提高性能<br />
         NSMutableArray *arrayM = [NSMutableArray arrayWithCapacity:dictCars.count];<br />
         for (NSDictionary *dict in dictCars) {<br />
             WJQCars *wcars = [[WJQCars alloc] initWithDict:dict];<br />
             [arrayM addObject:wcars];<br />
         }<br />
         self.cars = arrayM;<br />
     }<br />
     return self;<br />
 }

 + (instancetype)carsGroupWithDict:(NSDictionary *)dict {<br />
     return [[self alloc]initWithDict:dict];<br />
 }</pre>
</div>
<p>　　在&nbsp;ViewController.m&nbsp;中导入&nbsp;WJQCarsGroup.h、WJQCars.h&nbsp;。</p>
<div>
<pre class="prettyprint linenums"> //  ViewController.m<br />
 @interface ViewController () &lt;UITableViewDataSource&gt;<br />
 @property (nonatomic, strong) IBOutlet UITableView *tableView;<br />
 @property (nonatomic, strong) NSArray *car;<br />
 @end</pre>
</div>
<p>　　将&nbsp;tableView&nbsp;属性与&nbsp;Main.storyboard&nbsp;中拖入的&nbsp;Table View&nbsp;视图建立连接。并让&nbsp;ViewController&nbsp;遵守&nbsp;UITableViewDataSource&nbsp;协议。</p>
<div>
<pre class="prettyprint linenums"> //  ViewController.m<br />
 - (void)viewDidLoad {<br />
     [super viewDidLoad];<br />
     self.tableView.rowHeight = ;<br />
     self.tableView.dataSource = self;<br />
     NSLog(@"self.car.count = %d", self.car.count);<br />
 }

 // 从包中读取数据，实现字典转模型<br />
 - (NSArray *)car {<br />
     if (_car == nil) {<br />
         NSString *fullPath = [[NSBundle mainBundle] pathForResource:@"cars_total.plist" ofType:nil];<br />
         NSArray *arrayM = [NSArray arrayWithContentsOfFile:fullPath];<br />
         NSMutableArray *carsArray = [NSMutableArray array];<br />
         for (NSDictionary *dict in arrayM) {<br />
             WJQCarsGroup *carsGroup = [WJQCarsGroup carsGroupWithDict:dict];<br />
             [carsArray addObject:carsGroup];<br />
         }<br />
         _car = [carsArray copy];<br />
     }<br />
     return _car;<br />
 }

 #pragma mark - UITableViewDataSource

 - (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {<br />
     return self.car.count;<br />
 }

 - (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {<br />
     WJQCarsGroup *carsGroup = self.car[section];<br />
     return carsGroup.cars.count;<br />
 }

 - (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {<br />
     static NSString *identifier = @"car";<br />
     UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];<br />
     if (cell == nil) {<br />
         cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identifier];<br />
     }<br />
     WJQCarsGroup *carsGroup = self.car[indexPath.section];<br />
     WJQCars *cars = carsGroup.cars[indexPath.row];<br />
     cell.imageView.image = [UIImage imageNamed:cars.icon];<br />
     cell.textLabel.text = cars.name;<br />
     return cell;<br />
 }

 // 设置每组的标题<br />
 - (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {<br />
     WJQCarsGroup *carsGroup = self.car[section];<br />
     return carsGroup.title;<br />
 }

 // 设置首字母索引<br />
 - (NSArray *)sectionIndexTitlesForTableView:(UITableView *)tableView {<br />
     NSArray *title = [self.car valueForKeyPath:@"title"];　　// 使用KVC机制<br />
     return title;<br />
 }</pre>
</div>
<p>参考博客：<a href="http://www.cnblogs.com/iOS开发UI篇&mdash;使用嵌套模型完成的一个简单汽车图标展示程序" rel="external nofollow noreferrer">iOS开发UI篇&mdash;使用嵌套模型完成的一个简单汽车图标展示程序</a></p>
<p>实例代码：<a href="http://vdisk.weibo.com/s/DiY98QyXChyWt" rel="external nofollow noreferrer">http://vdisk.weibo.com/s/DiY98QyXChyWt</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx2x308.html">TJ2016 CTF Write up</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw42nl8.html">Draggabilly &ndash; 轻松实现拖放功能（Drag &amp;amp&semi; Drop）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlldvq.html">c语言结构体小知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oo1dx8.html">eclipse的插件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mzd28.html">Unity GUI内绘制贝塞尔曲线</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmk4319.html">VS2015中快捷注释代码块</a>
		</li>
						<li><a href="https://www.batexi.com/a/96od7lj9.html">SQL你必须知道的-增删改查与约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdelm5x9.html">&period;Net设计模式&lowbar;原型模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x5wx08.html">像jq那样获取对象的js原生方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj17228.html">查看mysql一些命令的数据库状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymvrm9.html">第一百零九节，JavaScript面向对象与原型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1076oq.html">Android权限解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ylekg8.html">Json技术使用代码示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/950l35e8.html">UI线程异常处理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yr2kr8.html">Android：CheckBox控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj0zk1q.html">Reflection的getCallerClass静态方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1go45q.html">linux下rocksdb的编译安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx610q.html">Hadoop优化 第一篇 &colon; HDFS&sol;MapReduce</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j17e649.html">10&period;13 Django随笔</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdpe6z9.html">MATLAB总结二</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rge1678.html">5分钟入门git模式开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3wx6q.html">监控mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3w1oq.html">&lbrack;零&rsqb;java8 函数式编程入门官方文档中文版 java&period;util&period;stream 中文版 流处理的相关概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwvw08.html">【转载】C&num;工具类：人民币金额转换为中文大写</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkpz1v8.html">php 使用Glob&lpar;&rpar;  查找文件技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jovjx8.html">Serialization</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mzleo8.html">页面内容不够高footer始终位于页面的最底部</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yel2w8.html">Dynamics 365新功能：可编辑的网格&lpar;行内编辑&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw6548.html">Easyui datagrid 设置内容超过单元格宽度时自动换行显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw7vl8.html">&amp;lt&semi;jsp&colon;useBean&amp;gt&semi;、&amp;lt&semi;jsp&colon;setProperty&amp;gt&semi;与&amp;lt&semi;jsp&colon;getProperty&amp;gt&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
